# test the calculator in 1972 mode

use IPC::Open3 qw(open3);

my @tests = (
    ['#1', 'I'],
    ['.1 <- #V2', 'OK'],
    ['.1', 'III'],
    ['.V1', 'xxxiiDCCLXXI'],
    # XXX more tests are necessary
);

my $maxtest = @tests;
print "1..$maxtest\n";

my @l = map { "-I$_" } @INC;
my $pid = open3(\*READ, \*WRITE, \*WRITE, $^X, @l, 'bin/intercalc', '--batch', '-mexpr', '-l1972');

select READ; $| = 1; select STDOUT;

my $testnum = 1;
for my $test (@tests) {
    my ($cmd, $res) = @$test;
    print READ "$cmd\n";
    my $line = <WRITE>;
    chomp $line;
    while ($line =~ /loading compiler/i) {
	$line = <WRITE>;
	chomp $line;
    }
    $line =~ s/^\s+//;
    my ($gr, $gc) = split(/\s+/, $line, 2);
    my $not = 'not ';
    if ($gr ne $res) {
	print STDERR "FAIL $testnum res ($gr ne $res)\n";
    } else {
	$not = '';
    }
    print "${not}ok ", $testnum++, "\n";
}

